"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.urlSearchParamsBodySerializer = exports.jsonBodySerializer = exports.formDataBodySerializer = exports.createConfig = exports.createClient = void 0;
const axios_1 = require("axios");
const utils_1 = require("./utils");
const createClient = (config) => {
    let _config = (0, utils_1.mergeConfigs)((0, utils_1.createConfig)(), config);
    const { auth } = _config, configWithoutAuth = __rest(_config, ["auth"]);
    const instance = axios_1.default.create(configWithoutAuth);
    const getConfig = () => (Object.assign({}, _config));
    const setConfig = (config) => {
        _config = (0, utils_1.mergeConfigs)(_config, config);
        instance.defaults = Object.assign(Object.assign(Object.assign({}, instance.defaults), _config), { headers: (0, utils_1.mergeHeaders)(instance.defaults.headers, _config.headers) });
        return getConfig();
    };
    const request = async (options) => {
        var _a, _b, _c, _d;
        const opts = Object.assign(Object.assign(Object.assign({}, _config), options), { axios: (_b = (_a = options.axios) !== null && _a !== void 0 ? _a : _config.axios) !== null && _b !== void 0 ? _b : instance, headers: (0, utils_1.mergeHeaders)(_config.headers, options.headers) });
        if (opts.security) {
            await (0, utils_1.setAuthParams)(Object.assign(Object.assign({}, opts), { security: opts.security }));
        }
        if (opts.body && opts.bodySerializer) {
            opts.body = opts.bodySerializer(opts.body);
        }
        const url = (0, utils_1.buildUrl)(opts);
        try {
            const _axios = opts.axios;
            const { auth } = opts, optsWithoutAuth = __rest(opts, ["auth"]);
            const response = await _axios(Object.assign(Object.assign({}, optsWithoutAuth), { data: opts.body, headers: opts.headers, params: opts.paramsSerializer ? opts.query : undefined, url }));
            let { data } = response;
            if (opts.responseType === 'json') {
                if (opts.responseValidator) {
                    await opts.responseValidator(data);
                }
                if (opts.responseTransformer) {
                    data = await opts.responseTransformer(data);
                }
            }
            return Object.assign(Object.assign({}, response), { data: data !== null && data !== void 0 ? data : {} });
        }
        catch (error) {
            const e = error;
            if (opts.throwOnError) {
                throw e;
            }
            e.error = (_d = (_c = e.response) === null || _c === void 0 ? void 0 : _c.data) !== null && _d !== void 0 ? _d : {};
            return e;
        }
    };
    return {
        buildUrl: utils_1.buildUrl,
        delete: (options) => request(Object.assign(Object.assign({}, options), { method: 'delete' })),
        get: (options) => request(Object.assign(Object.assign({}, options), { method: 'get' })),
        getConfig,
        head: (options) => request(Object.assign(Object.assign({}, options), { method: 'head' })),
        instance,
        options: (options) => request(Object.assign(Object.assign({}, options), { method: 'options' })),
        patch: (options) => request(Object.assign(Object.assign({}, options), { method: 'patch' })),
        post: (options) => request(Object.assign(Object.assign({}, options), { method: 'post' })),
        put: (options) => request(Object.assign(Object.assign({}, options), { method: 'put' })),
        request,
        setConfig,
    };
};
exports.createClient = createClient;
var utils_2 = require("./utils");
Object.defineProperty(exports, "createConfig", { enumerable: true, get: function () { return utils_2.createConfig; } });
Object.defineProperty(exports, "formDataBodySerializer", { enumerable: true, get: function () { return utils_2.formDataBodySerializer; } });
Object.defineProperty(exports, "jsonBodySerializer", { enumerable: true, get: function () { return utils_2.jsonBodySerializer; } });
Object.defineProperty(exports, "urlSearchParamsBodySerializer", { enumerable: true, get: function () { return utils_2.urlSearchParamsBodySerializer; } });
//# sourceMappingURL=index.js.map