import { type OptionsLegacyParser } from './client';
import type { MediaCreateMediaData, PointsOfInterestCreatePointOfInterestData } from './types.gen';
export declare const client: import("./client").Client;
export declare class AppService {
    static appGetAppInfo<ThrowOnError extends boolean = false>(options?: OptionsLegacyParser<unknown, ThrowOnError>): import("./client").RequestResult<unknown, unknown, ThrowOnError>;
    static appPing<ThrowOnError extends boolean = false>(options?: OptionsLegacyParser<unknown, ThrowOnError>): import("./client").RequestResult<unknown, unknown, ThrowOnError>;
}
export declare class LanguagesService {
    static languagesControllerGetLanguages<ThrowOnError extends boolean = false>(options?: OptionsLegacyParser<unknown, ThrowOnError>): import("./client").RequestResult<unknown, unknown, ThrowOnError>;
}
export declare class MediaService {
    static mediaCreateMedia<ThrowOnError extends boolean = false>(options: OptionsLegacyParser<MediaCreateMediaData, ThrowOnError>): import("./client").RequestResult<import("./types.gen").MediaDTO, unknown, ThrowOnError>;
}
export declare class PointsOfInterestService {
    static pointsOfInterestGetPointsOfInterest<ThrowOnError extends boolean = false>(options?: OptionsLegacyParser<unknown, ThrowOnError>): import("./client").RequestResult<import("./types.gen").GetPointsOfInterestsResponseDTO, import("./types.gen").ServerException, ThrowOnError>;
    static pointsOfInterestCreatePointOfInterest<ThrowOnError extends boolean = false>(options: OptionsLegacyParser<PointsOfInterestCreatePointOfInterestData, ThrowOnError>): import("./client").RequestResult<import("./types.gen").CreatePointOfInterestResponseDTO, import("./types.gen").ServerException, ThrowOnError>;
}
