// This file is auto-generated by @hey-api/openapi-ts

import { createClient, createConfig, type OptionsLegacyParser, formDataBodySerializer } from './client';
import type { AppGetAppInfoError, AppGetAppInfoResponse, AppPingError, AppPingResponse, LanguagesControllerGetLanguagesError, LanguagesControllerGetLanguagesResponse, MediaCreateMediaData, MediaCreateMediaError, MediaCreateMediaResponse, PointsOfInterestGetPointsOfInterestError, PointsOfInterestGetPointsOfInterestResponse, PointsOfInterestCreatePointOfInterestData, PointsOfInterestCreatePointOfInterestError, PointsOfInterestCreatePointOfInterestResponse } from './types.gen';

export const client = createClient(createConfig());

export class AppService {
    public static appGetAppInfo<ThrowOnError extends boolean = false>(options?: OptionsLegacyParser<unknown, ThrowOnError>) {
        return (options?.client ?? client).get<AppGetAppInfoResponse, AppGetAppInfoError, ThrowOnError>({
            ...options,
            url: '/api'
        });
    }
    
    public static appPing<ThrowOnError extends boolean = false>(options?: OptionsLegacyParser<unknown, ThrowOnError>) {
        return (options?.client ?? client).get<AppPingResponse, AppPingError, ThrowOnError>({
            ...options,
            url: '/api/ping'
        });
    }
    
}

export class LanguagesService {
    public static languagesControllerGetLanguages<ThrowOnError extends boolean = false>(options?: OptionsLegacyParser<unknown, ThrowOnError>) {
        return (options?.client ?? client).get<LanguagesControllerGetLanguagesResponse, LanguagesControllerGetLanguagesError, ThrowOnError>({
            ...options,
            url: '/api/languages'
        });
    }
    
}

export class MediaService {
    /**
     * Create media
     */
    public static mediaCreateMedia<ThrowOnError extends boolean = false>(options: OptionsLegacyParser<MediaCreateMediaData, ThrowOnError>) {
        return (options?.client ?? client).post<MediaCreateMediaResponse, MediaCreateMediaError, ThrowOnError>({
            ...options,
            ...formDataBodySerializer,
            headers: {
                'Content-Type': null,
                ...options?.headers
            },
            url: '/api/v1/media'
        });
    }
    
}

export class PointsOfInterestService {
    public static pointsOfInterestGetPointsOfInterest<ThrowOnError extends boolean = false>(options?: OptionsLegacyParser<unknown, ThrowOnError>) {
        return (options?.client ?? client).get<PointsOfInterestGetPointsOfInterestResponse, PointsOfInterestGetPointsOfInterestError, ThrowOnError>({
            ...options,
            url: '/api/v1/points-of-interest'
        });
    }
    
    public static pointsOfInterestCreatePointOfInterest<ThrowOnError extends boolean = false>(options: OptionsLegacyParser<PointsOfInterestCreatePointOfInterestData, ThrowOnError>) {
        return (options?.client ?? client).post<PointsOfInterestCreatePointOfInterestResponse, PointsOfInterestCreatePointOfInterestError, ThrowOnError>({
            ...options,
            url: '/api/v1/points-of-interest'
        });
    }
    
}