// This file is auto-generated by @hey-api/openapi-ts

export type CreateMediaInputDTO = {
    /**
     * Media id
     */
    id?: string;
    /**
     * Media file
     */
    file: (Blob | File);
    /**
     * Max media width to resize
     */
    width?: number;
    /**
     * Max media height to resize
     */
    height?: number;
};

export type CreatePointOfInterestInputDTO = {
    slug: string;
    mainMediaId: string;
    translations: Array<PointOfInterestTranslationInputDTO>;
};

export type CreatePointOfInterestResponseDTO = {
    data: PointOfInterestDTO;
};

export type ErrorCodes = 'VALIDATION_ERROR';

export type ErrorType = {
    code: (ErrorCodes);
    message: string;
    field?: string;
};

export type GetPointsOfInterestsResponseDTO = {
    data: Array<PointOfInterestDTO>;
};

export type MediaDTO = {
    id: string;
    url: string;
};

export type PointOfInterestDTO = {
    id: string;
    slug: string;
    mainMedia: MediaDTO;
    translations: Array<PointOfInterestTranslationDTO>;
};

export type PointOfInterestTranslationDTO = {
    name: string;
    preview: string;
    languageCode: string;
    content: {
        [key: string]: unknown;
    };
};

export type PointOfInterestTranslationInputDTO = {
    name: string;
    preview: string;
    languageCode: string;
    content: {
        [key: string]: unknown;
    };
};

export type ServerException = {
    errors: Array<ErrorType>;
    status: number;
};

export type AppGetAppInfoResponse = (unknown);

export type AppGetAppInfoError = unknown;

export type AppPingResponse = (unknown);

export type AppPingError = unknown;

export type LanguagesControllerGetLanguagesResponse = (unknown);

export type LanguagesControllerGetLanguagesError = unknown;

export type MediaCreateMediaData = {
    body: CreateMediaInputDTO;
};

export type MediaCreateMediaResponse = (MediaDTO);

export type MediaCreateMediaError = unknown;

export type PointsOfInterestGetPointsOfInterestResponse = (GetPointsOfInterestsResponseDTO);

export type PointsOfInterestGetPointsOfInterestError = (ServerException);

export type PointsOfInterestCreatePointOfInterestData = {
    body: CreatePointOfInterestInputDTO;
};

export type PointsOfInterestCreatePointOfInterestResponse = (CreatePointOfInterestResponseDTO);

export type PointsOfInterestCreatePointOfInterestError = (ServerException);